<radio>
  <div class="play_mobile visible-md-* hidden">
    <a class="sm2-icon-play-pause playing" onclick={toggleSong}></a>
    <a title="Previous" class="sm2-icon-previous" onclick={prevSong}></a>
    <a title="Next" class="sm2-icon-next"  onclick={nextSong}></a>
  </div>
  <div class="sm2-bar-ui fixed full-width" id="audio-player">
    <div class="sm2-left">
      <img riot-src={track_image} height=100 width=100>
    </div>
    <div class="bd sm2-main-controls">
      <div class="sm2-inline-texture"></div>
      <div class="sm2-inline-gradient"></div>
      <div class="sm2-inline-element sm2-inline-status">
      <div class="sm2-progress">
        <div class="sm2-row">
          <div class="sm2-inline-time">0:00</div>
          <div class="sm2-progress-bd">
            <div class="sm2-progress-track" onclick={moveCursor}>
              <div class="sm2-progress-bar"></div>
              <div><div class="icon-overlay"></div></div>
            </div>
          </div>
          <div class="sm2-inline-duration">0:00</div>
        </div>
      </div>
      </div>
      <div class="sm2-bottom">
      <div class="sm2-playlist">
        <span class="hidden-xs hidden-sm">{serie_title} - {serie_subtitle}</span>
        <span class="visible-md-*">{serie_title}</span>
        <div class="sm2-playlist-target"><ul class="sm2-playlist-bd"><li>{ track_number }. { track }</li></ul></div>
      </div>
      <div class="button-element-container  hidden-xs">
        <div class="onoffswitch-btn">
          <div class="onoffswitch">
            <input type="checkbox" name="onoffswitch" class="onoffswitch-checkbox" id="myonoffswitch" onclick={toggleAutoplay} checked>
            <label class="onoffswitch-label" for="myonoffswitch"></label>
          </div>
          <div class="onoffswitch-label-text">autoplay</div>
        </div>
        <div class="sm2-inline-element sm2-button-element">
          <div class="sm2-button-bd">
            <a title="Previous" class="sm2-inline-button sm2-icon-previous" onclick={prevSong}>&lt; previous</a>
          </div>
        </div>
        <div class="sm2-inline-element sm2-button-element">
          <div class="sm2-button-bd">
            <a class="sm2-inline-button sm2-icon-play-pause" onclick={toggleSong}></a>
          </div>
        </div>
        <div class="sm2-inline-element sm2-button-element">
          <div class="sm2-button-bd">
            <a title="Next" class="sm2-inline-button sm2-icon-next"  onclick={nextSong}></a>
          </div>
        </div>
      </div>
      </div>

  </div>
  <script>
    var _this = this
    this.player = null
    this.autoplay = true
    this.tracks = []
    this.duration = 0
    this.dragged = false
    this.current_track = {}
    this.is_registered = $("meta[name=registered]").attr("content") == "true"

    this.toHHMMSS = function (seconds) {
      var sec_num = parseInt(seconds, 10); // don't forget the second param
      var hours   = Math.floor(sec_num / 3600);
      var minutes = Math.floor((sec_num - (hours * 3600)) / 60);
      var seconds = sec_num - (hours * 3600) - (minutes * 60);

      if (hours   < 10) {hours   = "0"+hours;}
      if (minutes < 10) {minutes = "0"+minutes;}
      if (seconds < 10) {seconds = "0"+seconds;}
      return hours+':'+minutes+':'+seconds;
    }

    toggleSong(e) {
      this.player.paused ? this.player.play() : this.player.pause()
    }

    toggleAutoplay(e) {
      this.autoplay = !this.autoplay
    }

    moveCursor(e) {
      if(_this.dragged == false)
        _this.player.setPosition(e.offsetX * this.duration / $('.sm2-progress-track').width() * 1000)
    }

    prevSong(e) {
      soundManager.stopAll()
      _this.index--
      if(_this.index < 0) _this.index = _this.tracks.length - 1
      _this.playSong(_this.tracks[_this.index])
    }

    nextSong(e) {
      soundManager.stopAll()
      _this.index++
      _this.index = _this.index % _this.tracks.length
      _this.playSong(_this.tracks[_this.index])
    }

    this.playSong = function(track) {
      route('/'+_this.serie+'/'+_this.section+'/'+track.slug)
      $(".play_mobile").removeClass("hidden")
      _this.player = soundManager.getSoundById(track.slug)
      _this.player.play({
        whileplaying: function() {
          _this.duration = this.duration / 1000
          if(_this.is_registered == false && this.position > 60000 && track.free != true) {
            console.log(track)
            _this.player.stop()
            $('#login-modal').modal('show')
          } else {
            if(!$(".sm2-progress-ball").hasClass("drag")) {
              $(".sm2-progress-ball").css("left", this.position * 100 / this.duration + "%");
            }
            $(".sm2-progress-bar").css("width", this.position * 100 / this.duration + "%");
            $(".sm2-inline-time").html(_this.toHHMMSS(parseInt(this.position / 1000)))
            $(".sm2-inline-duration").html(_this.toHHMMSS(parseInt(this.duration / 1000)))
          }
          var inputId = '#' + track.slug
          $("body").find(inputId).addClass("active")
          $("body").find(inputId + " .track-overlay img").attr("src", '/btn-pause-pink.png')
          _this.update()
        },
        onpause: function() {
          var inputId = '#' + track.slug
          $(".workshop_section_track_img").removeClass("active")
          $("body").find(inputId).addClass("active")
          $("body").find(inputId + " .track-overlay img").attr("src", '/btn-play-pink.png')

          $('.sm2-icon-play-pause').removeClass('playing')
          $('.sm2-icon-play-pause').addClass('paused')
        },
        onplay: function() {
          $('.sm2-icon-play-pause').addClass('playing')
          $('.sm2-icon-play-pause').removeClass('paused')
          _this.track = track.title
          _this.track_image = track.image
          _this.track_number = track.number
          _this.serie_title = track.serie_title
          _this.serie_subtitle = track.serie_subtitle
          _this.free = track.free
          $("#audio-player").css('display','flex')
          var inputId = '#' + track.slug
          $(".workshop_section_track_img").removeClass("active")
          $("body").find(inputId).addClass("active")
          $("body").find(inputId + " .track-overlay img").attr("src", '/btn-pause-pink.png')
          _this.update()
        },
        onresume: function() {
          $('.sm2-icon-play-pause').addClass('playing')
          $('.sm2-icon-play-pause').removeClass('paused')
          _this.track = track.title
          _this.track_image = track.image
          _this.track_number = track.number
          _this.serie_title = track.serie_title
          _this.serie_subtitle = track.serie_subtitle
          _this.free = track.free
          $("#audio-player").css('display','flex')
          _this.update()
        },
        onfinish: function() {
          _this.index++
          _this.index = _this.index % _this.tracks.length
          if(_this.autoplay) _this.playSong(_this.tracks[_this.index])
        },
        onerror: function() {
          _this.player.pause()
        }
      })

      setTimeout(function() {
        if($("body").hasClass("mobile")) {
          _this.player.pause()
          $('.sm2-icon-play-pause').removeClass('playing')
          $('.sm2-icon-play-pause').addClass('paused')
        }
      }, 100)

    }

    eventHub.on('play', function(args) {
      _this.index = args.index
      _this.current_track = args
      _this.serie = args.serie
      _this.section = args.section

      console.log(args)
      _.each(args.hh, function(h) {
        var now = +new Date() / 1000
        if(h[0] < now && h[1] > now) _this.is_registered = true
      })

      soundManager.stopAll()
      soundManager.unload()
      soundManager.setup({multiShot: false});

      $.get("/ateliers/"+ args.serie + "/" + args.section + ".js", function(d) {
        _this.tracks = []

        d.section.tracks.forEach(function(track) {
          _this.tracks.push({ free: args.free, url: track.track_url, title: track.item.t, slug: track.item.slug, image: args.serie_img, number: track.item.n, serie_title: args.serie_title, serie_subtitle: args.serie_subtitle })
        })

        _this.tracks.forEach(function(track) {
          var id = track.slug
          soundManager.createSound({
            id: id,
            url: track.url
          });
        })
        _this.playSong(_this.tracks[args.index])
        _this.update()

      }, 'json')
    })

    this.on("mount", function() {
      var draggable = $('.sm2-progress-ball'); //element

      draggable.on('mousedown', function(e){
        _this.dragged = true

        var dr = $(this).addClass("drag");
        height = dr.outerHeight();
        width = dr.outerWidth();
        //ypos = dr.offset().top + height - e.pageY,
        xpos = dr.offset().left + width - e.pageX;
        offsetLeft = $('.sm2-main-controls')[0].offsetLeft + $('.sm2-progress-track')[0].offsetLeft

        $(document.body).on('mousemove', function(e){
          //var itop = e.pageY + ypos - height;
          var ileft = e.pageX + xpos - width - draggable.width() / 2;
          if(ileft < offsetLeft - draggable.width() / 2) ileft = offsetLeft - draggable.width() / 2
          if(ileft > $('.sm2-progress-track').width() + offsetLeft - draggable.width() / 2) ileft = $('.sm2-progress-track').width() + offsetLeft - draggable.width() / 2
          if(dr.hasClass("drag")){
            dr.offset({left: ileft});
          }
        }).on('mouseup', function(e){
          dr.removeClass("drag");
          var posX = e.pageX - offsetLeft - draggable.width() / 2
          _this.player.setPosition(posX * _this.duration / $('.sm2-progress-track').width() * 1000)
        });
      });
    })


  </script>
</radio>
